PUT User/{id}
Some tooltip text!
• 12 minutes to read
• 12 minutes to read
PUT /api/v1/User/{id}
Updates the existing User
NsApiSlow threshold: 2000 ms.
Online Restricted: ## The User agent is not available in Online by default. User management is not allowed for partner apps.
| Path Part | Type | Description |
|---|---|---|
| id | int32 | The User id to update. Required |
Query String Parameters
| Parameter Name | Type | Description |
|---|---|---|
| $select | string | Optional comma separated list of properties to include in the result. Other fields are then nulled out to reduce payload size: "Name,department,category" Default = show all fields. |
PUT /api/v1/User/{id}?$select=name,department,category/id
Request Headers
| Parameter Name | Description |
|---|---|
| Authorization | Supports 'Basic', 'SoTicket' and 'Bearer' schemes, depending on installation type. |
| X-XSRF-TOKEN | If not using Authorization header, you must provide XSRF value from cookie or hidden input field |
| Content-Type | Content-type of the request body: application/json, text/json, application/xml, text/xml, application/x-www-form-urlencoded, application/json-patch+json, application/merge-patch+json |
| Accept | Content-type(s) you would like the response in: application/json, text/json, application/xml, text/xml, application/json-patch+json, application/merge-patch+json |
| Accept-Language | Convert string references and multi-language values into a specified language (iso2) code. |
| SO-Language | Convert string references and multi-language values into a specified language (iso2) code. Overrides Accept-Language value. |
| SO-Culture | Number, date formatting in a specified culture (iso2 language) code. Partially overrides SO-Language/Accept-Language value. Ignored if no Language set. |
| SO-TimeZone | Specify the timezone code that you would like date/time responses converted to. |
| SO-AppToken | The application token that identifies the partner app. Used when calling Online WebAPI from a server. |
Request Body: entity
The User to be saved.
| Property Name | Type | Description |
|---|---|---|
| AssociateId | Integer | Primary key |
| Name | String | Initials, UserId - also used as login name for on-site installations. Identifies user in archives. |
| Rank | Integer | Rank order |
| Tooltip | String | Tooltip or other description |
| LicenseOwners | Array | The restricted and unrestricted module licenses grouped by license owner. These module licenses are either assigned or unassigned to this user |
| Role | Role | Users role for role-based security. Determines permissions and access rights for the user. |
| UserGroup | UserGroup | The main user group that this user belongs to. |
| OtherGroups | Array | The other groups this user is a member of, apart from the main user group. |
| Person | Person | The person associated with this user. Detailed information about the user |
| Deleted | Boolean | If true, the user is retired and should have no rights, not appear in lists, etc. |
| Lastlogin | String | Last login date |
| Lastlogout | String | Last logout date |
| EjUserId | Integer | ID of the ej user record corresponding to this associate; 0 for associates that are not ej users |
| RequestSignature | String | ej users request signature |
| Type | String | User type: 1=InternalAssociate, 2=ResourceAssociate, 3=ExternalAssociate, 4=AnonymousAssociate, 5=SystemAssociate |
| IsPersonRetired | Boolean | True if the user is retired and should have no rights, not appear in lists, etc. |
| IsOnTravel | Boolean | True if the user is on travel. |
| Credentials | Array | List of credentials registered for this user. i.e. valid authentication methods. |
| UserName | String | User name, a.k.a. Login name. This might be an e-mail address. |
| TicketCategories | Array | Request Ticket Categories assigned to the user. |
| NickName | String | The unique nick name for this user. Used in Service as an alias, similar to Name/Initials. |
| WaitingForApproval | Boolean | The user is waiting for an administrator to approve/grant her/him access. |
| ExtraFields | Object | Deprecated: Use {SuperOffice.CRM.Services.User.CustomFields} instead. Extra fields added to the carrier. This could be data from Plug-ins, the foreign key system, external applications, etc. |
| CustomFields | Object | Udef + Extra fields added to the carrier. Extra fields as defined by changes to database schema + user-defined fields as defined by admin. Custom fields combines user defined fields and extra fields into one bucket. The individual {SuperOffice.CRM.Services.User.ExtraFields} and |
| PostSaveCommands | Array | Post custom commands the client should execute after save has completed. |
Response:
User updated.
| Response | Description |
|---|---|
| 200 | User updated. |
| 400 | Bad request. Entity to save is not in request body. |
Response body: UserWithLinks
| Property Name | Type | Description |
|---|---|---|
| AssociateId | int32 | Primary key |
| Name | string | Initials, UserId - also used as login name for on-site installations. Identifies user in archives. |
| Rank | int32 | Rank order |
| Tooltip | string | Tooltip or other description |
| LicenseOwners | array | The restricted and unrestricted module licenses grouped by license owner. These module licenses are either assigned or unassigned to this user |
| Role | Role | Users role for role-based security. Determines permissions and access rights for the user. |
| UserGroup | UserGroup | The main user group that this user belongs to. Use MDO List name "usergroup" to get list items. |
| OtherGroups | array | The other groups this user is a member of, apart from the main user group. Use MDO List name "usergroup" to get list items. |
| Person | Person | The person associated with this user. Detailed information about the user Use MDO List name "person_new" to get list items. |
| Deleted | bool | If true, the user is retired and should have no rights, not appear in lists, etc. |
| Lastlogin | date-time | Last login date |
| Lastlogout | date-time | Last logout date |
| EjUserId | int32 | ID of the ej user record corresponding to this associate; 0 for associates that are not ej users |
| RequestSignature | string | ej users request signature |
| Type | string | User type: 1=InternalAssociate, 2=ResourceAssociate, 3=ExternalAssociate, 4=AnonymousAssociate, 5=SystemAssociate |
| IsPersonRetired | bool | True if the user is retired and should have no rights, not appear in lists, etc. |
| IsOnTravel | bool | True if the user is on travel. |
| Credentials | array | List of credentials registered for this user. i.e. valid authentication methods. |
| UserName | string | User name, a.k.a. Login name. This might be an e-mail address. |
| TicketCategories | array | Request Ticket Categories assigned to the user. Use MDO List name "ejCategory" to get list items. |
| NickName | string | The unique nick name for this user. Used in Service as an alias, similar to Name/Initials. |
| WaitingForApproval | bool | The user is waiting for an administrator to approve/grant her/him access. |
| ExtraFields | object | Deprecated: Use {SuperOffice.CRM.Services.User.CustomFields} instead. Extra fields added to the carrier. This could be data from Plug-ins, the foreign key system, external applications, etc. |
| CustomFields | object | Udef + Extra fields added to the carrier. Extra fields as defined by changes to database schema + user-defined fields as defined by admin. Custom fields combines user defined fields and extra fields into one bucket. The individual {SuperOffice.CRM.Services.User.ExtraFields} and UserDefinedFields properties are deprecated in favor of this combined collection. |
| PostSaveCommands | array | Post custom commands the client should execute after save has completed. |
| TableRight | TableRight | The carrier's table right |
| FieldProperties | object | Field property dictionary mapping field names to field access rights. |
| _Links | object |
Sample request
PUT /api/v1/User/{id}
Authorization: Basic dGplMDpUamUw
Accept: application/json; charset=utf-8
Accept-Language: en
Content-Type: application/json; charset=utf-8
{
"AssociateId": 476,
"Name": "Champlin, Metz and Lueilwitz",
"Rank": 487,
"Tooltip": "aut",
"LicenseOwners": [
{
"Name": "Larson-Hand",
"Description": "Integrated zero defect interface",
"RestrictedModuleLicenses": [
{},
{}
],
"UnrestrictedModuleLicenses": [
{},
{}
]
},
{
"Name": "Larson-Hand",
"Description": "Integrated zero defect interface",
"RestrictedModuleLicenses": [
{},
{}
],
"UnrestrictedModuleLicenses": [
{},
{}
]
}
],
"Role": null,
"UserGroup": null,
"OtherGroups": [
{
"Value": "reiciendis",
"Tooltip": "sit",
"Id": 532,
"Rank": 449,
"Deleted": false
},
{
"Value": "reiciendis",
"Tooltip": "sit",
"Id": 532,
"Rank": 449,
"Deleted": false
}
],
"Person": null,
"Deleted": false,
"Lastlogin": "2009-06-15T14:34:02.8719561+02:00",
"Lastlogout": "2008-12-16T14:34:02.8719561+01:00",
"EjUserId": 903,
"RequestSignature": "cumque",
"Type": "AnonymousAssociate",
"IsPersonRetired": false,
"IsOnTravel": true,
"Credentials": [
{
"Type": null,
"Value": "sint",
"DisplayValue": "aut"
},
{
"Type": null,
"Value": "sint",
"DisplayValue": "aut"
}
],
"UserName": "Fisher Inc and Sons",
"TicketCategories": [
{
"Id": 297,
"Name": "Homenick Group",
"ToolTip": "Dolores quo perspiciatis aut debitis in expedita.",
"Deleted": true,
"Rank": 107,
"Type": "impedit",
"ChildItems": [
{},
{}
],
"IconHint": "voluptatem",
"ColorBlock": 988,
"ExtraInfo": "ratione",
"StyleHint": "ut",
"FullName": "Mrs. Jan Zachariah Harris"
}
],
"NickName": "Schowalter Inc and Sons",
"WaitingForApproval": false,
"ExtraFields": {
"ExtraFields1": "harum",
"ExtraFields2": "quis"
},
"CustomFields": {
"CustomFields1": "repellat",
"CustomFields2": "nobis"
},
"PostSaveCommands": [
{
"Name": "D'Amore-Blanda",
"DisplayName": "Stokes-Kutch",
"Description": "Fundamental needs-based productivity",
"ToolTip": "Vel non quisquam dicta mollitia.",
"Actions": "Implicit",
"ActionData": "vero"
},
{
"Name": "D'Amore-Blanda",
"DisplayName": "Stokes-Kutch",
"Description": "Fundamental needs-based productivity",
"ToolTip": "Vel non quisquam dicta mollitia.",
"Actions": "Implicit",
"ActionData": "vero"
}
]
}
Sample response
HTTP/1.1 200 User updated.
Content-Type: application/json; charset=utf-8
{
"AssociateId": 56,
"Name": "McDermott, Terry and Abernathy",
"Rank": 694,
"Tooltip": "soluta",
"LicenseOwners": [
{
"Name": "Deckow, Koch and Hirthe",
"Description": "Organic 6th generation encoding",
"RestrictedModuleLicenses": [
{},
{}
],
"UnrestrictedModuleLicenses": [
{},
{}
],
"TableRight": null,
"FieldProperties": {
"fieldName": {
"FieldRight": null,
"FieldType": "System.Int32",
"FieldLength": 823
}
}
},
{
"Name": "Deckow, Koch and Hirthe",
"Description": "Organic 6th generation encoding",
"RestrictedModuleLicenses": [
{},
{}
],
"UnrestrictedModuleLicenses": [
{},
{}
],
"TableRight": null,
"FieldProperties": {
"fieldName": {
"FieldRight": null,
"FieldType": "System.Int32",
"FieldLength": 823
}
}
}
],
"Role": null,
"UserGroup": null,
"OtherGroups": [
{
"Value": "eaque",
"Tooltip": "labore",
"Id": 275,
"Rank": 347,
"Deleted": true,
"TableRight": null,
"FieldProperties": {
"fieldName": {
"FieldRight": null,
"FieldType": "System.Int32",
"FieldLength": 60
}
}
}
],
"Person": null,
"Deleted": false,
"Lastlogin": "2011-02-03T14:34:02.8759566+01:00",
"Lastlogout": "2022-11-12T14:34:02.8759566+01:00",
"EjUserId": 209,
"RequestSignature": "perspiciatis",
"Type": "AnonymousAssociate",
"IsPersonRetired": false,
"IsOnTravel": true,
"Credentials": [
{
"Type": null,
"Value": "delectus",
"DisplayValue": "magni",
"TableRight": null,
"FieldProperties": {
"fieldName": {
"FieldRight": null,
"FieldType": "System.Int32",
"FieldLength": 998
}
}
},
{
"Type": null,
"Value": "delectus",
"DisplayValue": "magni",
"TableRight": null,
"FieldProperties": {
"fieldName": {
"FieldRight": null,
"FieldType": "System.Int32",
"FieldLength": 998
}
}
}
],
"UserName": "Witting, Little and Gleichner",
"TicketCategories": [
{
"Id": 795,
"Name": "Homenick, Beahan and Weimann",
"ToolTip": "Dolore optio nobis assumenda qui doloremque.",
"Deleted": false,
"Rank": 834,
"Type": "temporibus",
"ChildItems": [
{},
{}
],
"IconHint": "consequatur",
"ColorBlock": 457,
"ExtraInfo": "sunt",
"StyleHint": "quo",
"FullName": "John Smith",
"TableRight": null,
"FieldProperties": {
"fieldName": {
"FieldRight": null,
"FieldType": "System.Int32",
"FieldLength": 854
}
}
}
],
"NickName": "Zboncak, Hoppe and Mertz",
"WaitingForApproval": true,
"ExtraFields": {
"ExtraFields1": "non",
"ExtraFields2": "qui"
},
"CustomFields": {
"CustomFields1": "saepe",
"CustomFields2": "saepe"
},
"PostSaveCommands": [
{
"Name": "Ziemann, Mills and Mraz",
"DisplayName": "Ratke LLC",
"Description": "Triple-buffered optimal portal",
"ToolTip": "Qui odio quia.",
"Actions": "Implicit",
"ActionData": "assumenda",
"TableRight": null,
"FieldProperties": {
"fieldName": {
"FieldRight": null,
"FieldType": "System.Int32",
"FieldLength": 859
}
}
}
],
"TableRight": null,
"FieldProperties": {
"fieldName": {
"FieldRight": null,
"FieldType": "System.Int32",
"FieldLength": 131
}
},
"_Links": {
"Self": "https://www.example.com/api/v1/project/321",
"Archive": "https://www.example.com/api/v1/project"
}
}